package net.es.oscars.policy.database;

import net.es.oscars.database.GenericHibernateDAO;

public class PolicyClassCriterionDAO extends GenericHibernateDAO<PolicyClassCriterion, Integer>{
    public PolicyClassCriterionDAO(String dbName){
        this.setDatabase(dbName);
    }
    
    public PolicyClassCriterion findByClassTypeValue(Integer policyClassId, String type, String value){
        String sql = "SELECT * FROM policyClassCriteria WHERE policyClassId=? AND typeId=(SELECT id FROM policyClassCriterionTypes WHERE name=?) AND value=?";
        if(policyClassId == null){
            return null;
        }
        return (PolicyClassCriterion) this.getSession().createSQLQuery(sql)
                                          .addEntity(PolicyClassCriterion.class)
                                          .setInteger(0, policyClassId)
                                          .setString(1, type)
                                          .setString(2, value)
                                          .uniqueResult();
        
    }
}
